﻿using System;
using System.Runtime.InteropServices; // DLL Import
using System.IO;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.ComponentModel;
using System.Text.RegularExpressions;

namespace SDR
{
    public partial class Form1:Form // メインのフォームのクラス
    {
        // int debugMode; // 0:honban

        Graphics grfx, wfgrfx;
        Bitmap bmpWf;
        Osc osc1 = new Osc();   // 入力信号用の発信器を作成
        Osc osc2 = new Osc();   // ミキサ用の発信器を作成
        Osc osc3 = new Osc();   // BFO用の発信器を作成
        private BackgroundWorker bw = new BackgroundWorker();
        volatile bool abortflag = false; // スレッド中止フラグ
        String FileName = "";
        bool FileMode = false;  // ファイル読み込みモードフラグ
        bool silent = false;    // サイレントモード
        bool osc2on;
        bool[] filDispWidth = new bool[1024];
        WaveFile wave = new WaveFile();    // WAVEファイル読み込みクラス作成
        Fft fft = new Fft(1024, 2); // FFT演算用クラス作成
        Spectrum sp = new Spectrum();   // スペクトラム表示用クラス
        Signal signal = new Signal(); // 信号処理用のクラス作成
        Filter filter = new Filter(); // 選局用のフィルタクラスを作成
        int TrackValue = 0;     // チューニング用の値
        int track3Value = 0;    // スペクトラム濃淡用の値
        int track4Value = 0;    // スペクトラム明るさ用の値
        int track5Value = 0;    // WF濃淡用の値
        int track6Value = 0;    // WF明るさ用の値

        double afgain = 1.0;    // モニタ出力ボリューム値
        double cursor = 10.0;   // チューニングカーソル
        double freq;    // 周波数表示用変数
        double level;   // 信号強度用変数
        double filterHigh;  // textBox8 フィルタ上限周波数
                            //      double fikterHighX2;// フィルタ上限周波数 * 2
        double filterLow;   // textBox9 フィルタ下限周波数
                            //      double filetrLowX2; // フィルタ下限周波数 * 2
        int ssbFilterHigh = 1500;
        int ssbFilterLow = 100;
        string cwToneFreq = "700";
        int cwFilterHigh = 300;
        int cwFilterLow = 0;
        int amFilterHigh = 4000;
        int amFilterLow = 0;
        int inputKind; // 10:Line 12:File

        string iniFileName = "SDRsoft88.ini";

        //
        //  起動時の初期化
        //
        public Form1()
        {
            InitializeComponent();  // デフォルトの初期設定処理を行なう
            pictureBox1.Image = new Bitmap(pictureBox1.Width, pictureBox1.Height);//FFT表示用のイメージを作成
            grfx = Graphics.FromImage(pictureBox1.Image);// 作成したイメージをフォームに貼り付ける
            bmpWf = new Bitmap(pictureBox2.Width, pictureBox2.Height);//waterFall用のイメージを作成
            pictureBox2.Image = bmpWf;//waterFall用のイメージを作成
            Bitmap bitmapCopy = new Bitmap(pictureBox2.Width, pictureBox2.Height);//waterFallコピー用のイメージを作成
            wfgrfx = Graphics.FromImage(pictureBox2.Image);// 作成したイメージをフォームに貼り付ける
            // this.DoubleBuffered = true; 有っても無くても速度変化を感じない＝既定でダブルバッファの模様
        }
        //
        //  画面が表示される際に一度だけ呼ばれる
        //
        private void Form1_Load(object sender, EventArgs e)
        {
            restart(); // iniファイルがあれば前回終了時の動作状態、なければ出荷時状態 にセット
 
            // 【ワレコのC#】Formアプリ 前回終了時 ウインドウ位置・サイズを記憶復元
            //   https://www.wareko.jp/blog/c-sharp-form-application-save-restore-window-state-position-size
            int i = 0;
                //すべてのディスプレイを列挙する
                foreach (System.Windows.Forms.Screen s in System.Windows.Forms.Screen.AllScreens)
                {
                    i++;
                }
                //　前回のScreenがSecondで今回Primaryしかない場合は例外処置
                if (i == 1)
                {
                    //ディスプレイの高さ
                    int h = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height;
                    //ディスプレイの幅
                    int w = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width;
                    if (this.Location.X >= w || this.Location.Y >= h)
                    {
                        this.SetBounds(20, 20, 200, 100, BoundsSpecified.Location);
                    }
                }
                this.WindowState = FormWindowState.Normal;

            // AssemblyTitleの取得
            // https://dobon.net/vb/dotnet/file/myversioninfo.html
            System.Reflection.AssemblyTitleAttribute asmttl =
                (System.Reflection.AssemblyTitleAttribute)
                Attribute.GetCustomAttribute(
                    System.Reflection.Assembly.GetExecutingAssembly(),
                    typeof(System.Reflection.AssemblyTitleAttribute));
            this.Text = asmttl.Title; // 現在のフォーム タイトルに表示            

            // dobon.net 自分自身のバージョン情報を取得する
            // https://dobon.net/vb/dotnet/file/myversioninfo.html
            System.Diagnostics.FileVersionInfo ver =
                System.Diagnostics.FileVersionInfo.GetVersionInfo(
                System.Reflection.Assembly.GetExecutingAssembly().Location);
            this.Text += "  Ver " + ver.FileVersion; // 現在のフォーム タイトルに表示            

            //初期設定
            //radioButton21.Checked = true;

            //動作開始指示
            bw.DoWork += new DoWorkEventHandler(SignalWork);    // マルチスレッド動作用のワーカーを作成
            bw.RunWorkerAsync();    // 信号処理用のスレッドを開始
        }
        //
        // iniファイルがあれば前回終了時の動作状態、なければ出荷時状態 にセット
        //
        private void restart()
        {
            // dobon.net 自分のアプリケーションの実行ファイルのパスを取得する
            // https://dobon.net/vb/dotnet/vb6/apppath.html
            string thisExeLocation = System.IO.Path.GetDirectoryName(
                System.Reflection.Assembly.GetExecutingAssembly().Location);

            // dobon.net 現在のプロセスのカレントディレクトリを設定する
            // https://dobon.net/vb/dotnet/file/currentdirectory.html
            System.IO.Directory.SetCurrentDirectory(thisExeLocation);

            //
            // ********　.iniファイルを読み込む **********
            string[] lines = null;
            try
            {
                //文字コード
                System.Text.Encoding enc = System.Text.Encoding.GetEncoding("shift_jis");
                //System.Text.Encoding enc = System.Text.Encoding.UTF8;

                //テキストファイルの中身を、行ごとの配列として、すべて読み込む
                lines = System.IO.File.ReadAllLines(iniFileName, enc);
            }
            catch (Exception exc)
            {
                if (exc is ArgumentNullException) textBox2.Text = "ERRiniFile";
            }

            if (lines != null)
            {
                int fileMaxlineNo = lines.Length; // 配列の要素数、すなわち行数

                for (int el = 0; el < fileMaxlineNo; el++)
                {
                    string line = lines[el].Replace('　', ' '); // 全角スペースを半角に置き換え
                    line = line.Trim(' '); // 行頭と行尻の半角スペースを取り除く
                    line = Regex.Replace(line, @"\s+", " "); // 複数のスペースを1つのスペースに置き換える


                    // ','または' 'で区切られたパラメーターを１個ずつ配列に代入する
                    // 連続する','または' 'は1つとみなす
                    char[] splitChars = { ',', ' ' }; // コンマ　または　スペース
                    string[] strArray = line.Split(splitChars, StringSplitOptions.RemoveEmptyEntries);

                    if (strArray.Length == 0) { } // 配列要素が１個も作られなかった(即ち　スペース行)
                    else
                    {
                        int lineLength = line.Length;

                        if ((lineLength == 0) | (lineLength >= 2 && strArray[0].Substring(0, 2) == "//"))// 行全体がコメント
                        { } // なにもしない
                        else
                        {
                            int paraLength = strArray[0].Length; // １個目の要素の文字数
                            if (paraLength >= 6 && strArray[0].Substring(0, 5) == "Left=")
                            {
                                this.Left = int.Parse(strArray[0].Substring(5, paraLength - 5));
                            }
                            if (paraLength >= 5 && strArray[0].Substring(0, 4) == "Top=")
                            {
                                this.Top = int.Parse(strArray[0].Substring(4, paraLength - 4));
                            }
                            if (paraLength >= 7 && strArray[0].Substring(0, 6) == "Width=")
                            {
                                this.Width = int.Parse(strArray[0].Substring(6, paraLength - 6));
                            }
                            if (paraLength >= 8 && strArray[0].Substring(0, 7) == "Height=")
                            {
                                this.Height = int.Parse(strArray[0].Substring(7, paraLength - 7));
                            }
                            // 前回終了時の値に戻す
                            {
                                //入力切換
                                if (paraLength >= 8 && strArray[0].Substring(0, 7) == "inFile=")
                                { textBox2.Text = strArray[0].Substring(7, paraLength - 7); }
                                if (paraLength == 7 && strArray[0].Substring(0, 7) == "input=L")
                                { radioButton10.Checked = true; inputKind = 10; }
                                if (paraLength == 7 && strArray[0].Substring(0, 7) == "input=F")
                                { radioButton12.Checked = true; inputKind = 12; }
                                if (paraLength == 7 && strArray[0].Substring(0, 7) == "IQrev=1")
                                { checkBox2.Checked = true; }
                                if (paraLength == 7 && strArray[0].Substring(0, 7) == "IQrev=0")
                                { checkBox2.Checked = false; }
                                //Receve AMP
                                if (paraLength >= 11 && strArray[0].Substring(0, 10) == "trackBar9=")
                                {
                                    trackBar9.Value = int.Parse(strArray[0].Substring(10, paraLength - 10));
                                    textBox3.Text = (trackBar9.Value * 0.1).ToString();
                                }
                                if (paraLength >= 9 && strArray[0].Substring(0, 8) == "RecvAmp=")
                                { textBox3.Text = strArray[0].Substring(8, paraLength - 8); }
                                //第１Mixer
                                if (paraLength == 11 && strArray[0].Substring(0, 11) == "No1MixRev=1")
                                { checkBox5.Checked = true; }
                                if (paraLength == 11 && strArray[0].Substring(0, 11) == "No1MixRev=0")
                                { checkBox5.Checked = false; }
                                if (paraLength >= 6 && strArray[0].Substring(0, 5) == "freq=")
                                { textBox5.Text = strArray[0].Substring(5, paraLength - 5);}
                                if (paraLength >= 11 && strArray[0].Substring(0, 10) == "No1mixOSC=")
                                { textBox4.Text = strArray[0].Substring(10, paraLength - 10); }
                                if (paraLength >= 11 && strArray[0].Substring(0, 10) == "trackBar2=")
                                { trackBar2.Value = int.Parse(strArray[0].Substring(10, paraLength - 10)); trackBar2_Sc(); }
                                //フィルタ
                                // if (paraLength >= 8 && strArray[0].Substring(0, 7) == "FIRtap=")
                                // { textBox7.Text = strArray[0].Substring(7, paraLength - 7); }
                                if (paraLength >= 11 && strArray[0].Substring(0, 10) == "trackBar7=")
                                {
                                    trackBar7.Value = int.Parse(strArray[0].Substring(10, paraLength - 10));
                                }
                                if (paraLength >= 9 && strArray[0].Substring(0, 8) == "MinFreq=")
                                { textBox9.Text = strArray[0].Substring(8, paraLength - 8); filterHigh = int.Parse(textBox8.Text); }

                                if (paraLength >= 11 && strArray[0].Substring(0, 10) == "trackBar8=")
                                {
                                    trackBar8.Value = int.Parse(strArray[0].Substring(10, paraLength - 10));
                                }
                                if (paraLength >= 9 && strArray[0].Substring(0, 8) == "MaxFreq=")
                                { textBox8.Text = strArray[0].Substring(8, paraLength - 8); filterHigh = int.Parse(textBox8.Text); }
                                //第２Mix
                                if (paraLength == 6 && strArray[0].Substring(0, 6) == "osc2=1") { osc2on = true; }
                                else if (paraLength == 6 && strArray[0].Substring(0, 6) == "osc2=0") { osc2on = false; }
                                if (paraLength >= 11 && strArray[0].Substring(0, 10) == "No2mixOSC=")
                                { textBox10.Text = strArray[0].Substring(10, paraLength - 10); }
                                if (paraLength >= 16 && strArray[0].Substring(0, 15) == "WindowFunction=")
                                { comboBox1.SelectedIndex = int.Parse(strArray[0].Substring(15, paraLength - 15)); }
                                //検波
                                if (paraLength == 6 && strArray[0].Substring(0, 6) == "Det=LS")
                                { radioButton14.Checked = true; }
                                if (paraLength == 6 && strArray[0].Substring(0, 6) == "Det=AM")
                                { radioButton15.Checked = true; }
                                if (paraLength == 6 && strArray[0].Substring(0, 6) == "Det=US")
                                { radioButton21.Checked = true; }
                                if (paraLength == 6 && strArray[0].Substring(0, 6) == "Det=CN")
                                { radioButton22.Checked = true; }
                                if (paraLength == 6 && strArray[0].Substring(0, 6) == "Det=CR")
                                { radioButton23.Checked = true; }
                                //AF モニタ音量
                                if (paraLength >= 11 && strArray[0].Substring(0, 10) == "trackBar1=")
                                { trackBar1.Value = int.Parse(strArray[0].Substring(10, paraLength - 10)); }
                                //afgain = (double)trackBar1.Value / trackBar1.Maximum;
                                afgain = (double)trackBar1.Value;
                                //変調
                                //if (paraLength == 12 && strArray[0].Substring(0, 12) == "Modulation=0")
                                //{ radioButton18.Checked = true; }
                                //if (paraLength == 12 && strArray[0].Substring(0, 12) == "Modulation=3")
                                //{ radioButton19.Checked = true; }
                                //if (paraLength == 12 && strArray[0].Substring(0, 12) == "Modulation=4")
                                //{ radioButton20.Checked = true; }
                                //スペクトラム表示
                                if (paraLength == 10 && strArray[0].Substring(0, 10) == "Spectrum=0")
                                { radioButton1.Checked = true; }
                                if (paraLength == 10 && strArray[0].Substring(0, 10) == "Spectrum=1")
                                { radioButton2.Checked = true; }
                                if (paraLength == 10 && strArray[0].Substring(0, 10) == "Spectrum=2")
                                { radioButton3.Checked = true; }
                                if (paraLength >= 11 && strArray[0].Substring(0, 10) == "trackBar4=") //  スペクトラム明るさ
                                {
                                    trackBar4.Value = int.Parse(strArray[0].Substring(10, paraLength - 10));
                                    track4Value = trackBar4.Value;
                                }
                                if (paraLength >= 11 && strArray[0].Substring(0, 10) == "trackBar5=") //  WF濃さ
                                {
                                    trackBar5.Value = int.Parse(strArray[0].Substring(10, paraLength - 10));
                                    track5Value = trackBar5.Value;
                                }
                                if (paraLength >= 11 && strArray[0].Substring(0, 10) == "trackBar6=") //  WF明るさ
                                {
                                    trackBar6.Value = int.Parse(strArray[0].Substring(10, paraLength - 10));
                                    track6Value = trackBar6.Value;
                                }
                            }
                        }
                    }
                }
                SetupFilter();
            }
            else
            {
                this.button4.PerformClick(); // iniファイルがないので出荷時状態に設定する
            }
            SetTextBox4(); // 第1局発周波数をセット 
            comboBox1.SelectedIndex = 2;// FFT窓関数をBlackmannに指定
            checkBox8.Checked = true;   // AGC ON

            // 直前の終了時の入力指定のための「特別処置」 この特別処置がないとファイル入力での前回終了が再開しない
            if (inputKind == 12) radioButton12.Checked = true;
        }

        //
        //　フォームが閉じられた時の処理
        //
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            abortflag = true;   // 信号処理スレッドを中止させる
            string strings = "WindowState=" + this.WindowState + "\r\n";
            if (this.WindowState == FormWindowState.Normal)
            {
                // ウインドウステートがNormalな場合には位置（location）とサイズ（size）を記憶する。
                strings += "Top=" + this.Top + "\r\n";
                strings += "Left=" + this.Left + "\r\n";
                strings += "Width=" + this.Width + "\r\n";
                strings += "Height=" + this.Height + "\r\n";
            }
            else
            {
                // もし最小化（minimized）や最大化（maximized）の場合には、RestoreBounds(最小化や最大化前の値)を記憶する。
                strings += "Top=" + RestoreBounds.Top + "\r\n";
                strings += "Left=" + RestoreBounds.Left + "\r\n";
                strings += "Width=" + RestoreBounds.Width + "\r\n";
                strings += "Height=" + RestoreBounds.Height + "\r\n";
            }

            // 終了時の値を次の起動時に生かすために退避しておく
            {
                //入力切換
                if (radioButton10.Checked == true) strings += "input=L" + "\r\n"; // ライン入力
                if (radioButton12.Checked == true) strings += "input=F" + "\r\n"; // ファイル入力
                strings += "inFile=" + textBox2.Text + "\r\n";
                if (checkBox2.Checked == true) strings += "IQrev=" + "1" + "\r\n";
                if (checkBox2.Checked != true) strings += "IQrev=" + "0" + "\r\n";
                //Receve AMP
                strings += "trackBar9=" + trackBar9.Value + "\r\n";
                strings += "RecvAmp=" + textBox3.Text + "\r\n";
                //第１Mixer
                if (checkBox5.Checked == true) strings += "No1MixRev=" + "1" + "\r\n";
                if (checkBox5.Checked == false) strings += "No1MixRev=" + "0" + "\r\n";
                strings += "freq=" + textBox5.Text + "\r\n";
                strings += "No1mixOSC=" + textBox4.Text + "\r\n";
                strings += "trackBar2=" + trackBar2.Value + "\r\n";
                //フィルタ
                // strings += "FIRtap=" + textBox7.Text + "\r\n";
                strings += "trackBar7=" + trackBar7.Value + "\r\n";
                strings += "trackBar8=" + trackBar8.Value + "\r\n";
                strings += "MaxFreq=" + textBox8.Text + "\r\n";
                strings += "MinFreq=" + textBox9.Text + "\r\n";
                //第２Mix
                if (osc2on == true) {strings += "osc2=1" + "\r\n"; } else{ strings += "osc2=0" + "\r\n"; }
                strings += "No2mixOSC=" + textBox10.Text + "\r\n";
                //検波
                if (radioButton14.Checked == true) strings += "Det=LS" + "\r\n";    // LSB
                if (radioButton15.Checked == true) strings += "Det=AM" + "\r\n";    // AM
                if (radioButton21.Checked == true) strings += "Det=US" + "\r\n";    // USB
                if (radioButton22.Checked == true) strings += "Det=CN" + "\r\n";    // CW
                if (radioButton23.Checked == true) strings += "Det=CR" + "\r\n";    // CWR
                //AF モニタ音量
                strings += "trackBar1=" + trackBar1.Value + "\r\n";
                //変調
                //if (radioButton18.Checked == true) strings += "Modulation=0" + "\r\n";    // オフ
                //if (radioButton19.Checked == true) strings += "Modulation=3" + "\r\n";    // AM
                //if (radioButton20.Checked == true) strings += "Modulation=4" + "\r\n";    // FM
                //スペクトラム表示
                if (radioButton1.Checked == true) strings += "Spectrum=0" + "\r\n";    // 0kHzから8kHz
                if (radioButton2.Checked == true) strings += "Spectrum=1" + "\r\n";    // -4kHzから4kHz
                if (radioButton3.Checked == true) strings += "Spectrum=2" + "\r\n";    // -8kHzから8kHz
                strings += "WindowFunction=" + comboBox1.SelectedIndex + "\r\n"; //  窓関数の種類番号
                strings += "trackBar4=" + trackBar4.Value + "\r\n";
                strings += "trackBar5=" + trackBar5.Value + "\r\n";
                strings += "trackBar6=" + trackBar6.Value + "\r\n";
            }

            // .iniファイルに書き込む準備
            // dobon.net 自分のアプリケーションの実行ファイルのパスを取得する
            // https://dobon.net/vb/dotnet/vb6/apppath.html
            string thisExeLocation = System.IO.Path.GetDirectoryName(
            System.Reflection.Assembly.GetExecutingAssembly().Location);

            // dobon.net 現在のプロセスのカレントディレクトリを設定する
            // https://dobon.net/vb/dotnet/file/currentdirectory.html
            System.IO.Directory.SetCurrentDirectory(thisExeLocation);

            //文字コード(ここでは、Shift JIS)
            System.Text.Encoding enc = System.Text.Encoding.GetEncoding("shift_jis");

            // .iniファイルにstringsの内容を書き込む
            // ファイルが存在しているときは、上書きする
            // フォルダ名とファイル名を結合して絶対パスを作成する
            // https://dobon.net/vb/dotnet/file/pathcombine.html
            string filePath = System.IO.Path.Combine(thisExeLocation,iniFileName);
            System.IO.File.WriteAllText(filePath, strings, enc);
        }
        // 第1局発周波数をセット
        private void SetTextBox4()
        {
            if (radioButton14.Checked || radioButton21.Checked) // LSB or USB
            {
                // 上限周波数を第2局発OSC周波数とする
                if (radioButton14.Checked == true) textBox10.Text = "-" + textBox8.Text; // LSB
                else if (radioButton21.Checked == true) textBox10.Text = textBox8.Text;  // USB
                try
                {
                    // BFO周波数分だけずらした値を第１局発OSC周波数とする
                    textBox4.Text = (GetTextValue(textBox5) + (osc2on ? GetTextValue(textBox10) : 0)).ToString();
                }
                catch (InvalidOperationException) { }  // エラーがあればここへ(実際は来ない)
            }
            else
            {
                textBox4.Text = textBox5.Text; // ずらさないで目的周波数を第１OSC周波数とする
            }
        }

        //  スペクトラム表示スタイルを取得する
        //
        private int GetDispStyle()
        {
            if(radioButton1.Checked)
                return 0;   // 0kHzから4kHzモード
            else if(radioButton2.Checked)
                return 1;   // -4kHzから4kHzモード
            else return 2;  // -8kHzから8kHzモード
        }

        //
        //  テキストボックス内の文字列から数値を得る
        //
        private double GetTextValue(TextBox tb)
        {
            String s = tb.Text; // テキストボックスの文字列を取得
            double val;
            try
            {val = Double.Parse(s);}// テキストボックスの文字を数字に変換を試みる
            catch(FormatException)  // 数字としておかしな文字列なら
            {val = 0; tb.Text = "0";}// 数値は0にしてテキストボックス内のおかしな文字列も0にする
            return val;// 値をもって帰る
        }

        //
        //  FIRフィルタの特性を設定する
        //
        void SetupFilter()
        {
            int taps;
            double high, low;
            // taps = (int)GetTextValue(textBox7);  // TAP数を得る
            taps = 255;  // TAP数

            high = GetTextValue(textBox8) / 16000;  // 上限周波数を得る
            low = GetTextValue(textBox9) / 16000;   // 下限周波数を得る
            if (taps < 3) taps = 3;         // TAP数の下限は3
            if (taps > 1024) taps = 1023;   // TAP数の上限は1023
            if (high > 0.5) high = 0.5;     // 上限周波数は0.5まで(ナイキスト周波数)
            if (low > 0.5) low = 0.5;       // 下限周波数は0.5まで(ナイキスト周波数)
            filter.CreateFirFilter(taps, low, high);    // FIRフィルタの帯域を設定する

            SetFilterWidth(); // スペクトラムに表示するフィルタ幅を設定
        }

        // スペクトラムに表示するフィルタ幅を設定
        void SetFilterWidth()
        {
            int filDispLow, filDispHigh;
            
            for (int i = 0; i < 1024; i++)
            {
               filDispWidth[i] = false;
            }
            
            filDispLow = 100; filDispHigh = 200; // 仮の値
            if (radioButton14.Checked) // LSB
            {
                filDispHigh = (int)GetTextValue(textBox5) - (int)filterLow; // 受信周波数－フィルタ下限周波数
                filDispLow = (int)GetTextValue(textBox5) - (int)filterHigh * 2;  // 受信周波数－フィルタ上限周波数*2
                FilDispW(filDispLow, filDispHigh);
            }
            else if (radioButton21.Checked) // USB
            {
                filDispLow = (int)GetTextValue(textBox5) + (int)filterLow; // 受信周波数＋フィルタ下限周波数
                filDispHigh = (int)GetTextValue(textBox5) + (int)filterHigh * 2;  // 受信周波数＋フィルタ上限周波数*2
                FilDispW(filDispLow, filDispHigh);
            }
            else
            {
                filDispLow = (int)GetTextValue(textBox5) - (int)filterHigh;  // 受信周波数－フィルタ上限周波数
                filDispHigh = (int)GetTextValue(textBox5) - (int)filterLow;  // 受信周波数－フィルタ下限周波数
                FilDispW(filDispLow, filDispHigh);
                filDispLow = (int)GetTextValue(textBox5) + (int)filterLow;  // 受信周波数＋フィルタ下限周波数
                filDispHigh = (int)GetTextValue(textBox5) + (int)filterHigh;  // 受信周波数＋フィルタ上限周波数
                FilDispW(filDispLow, filDispHigh);
            }
        }

        private void FilDispW(int filDispLow, int filDispHigh)
        {
            double step; int step_int;
            if (filDispLow > filDispHigh)
            {
                int saveLow = filDispLow;
                filDispLow = filDispHigh;
                filDispHigh = saveLow;
            }
            step = 0;
            for (int i = 0; i < 511; i++)
            {
                step_int = (int)step;
                if (filDispLow <= step_int && step_int <= filDispHigh) filDispWidth[i] = true;
                step = step + 15.625;
            }
            step = -8000;
            for (int i = 512; i < 1024; i++)
            {
                step_int = (int)step;
                if (filDispLow <= step_int && step_int <= filDispHigh) filDispWidth[i] = true;
                step = step + 15.625;
            }
        }

        // 一木裕貴　Javaによる音のFourier解析　大浦 FFT の書き換え　テストプログラムの実行
        // FFT変換、逆変換　精度確認用
        private void Putdata(int nini, int nend, double[] a, double rnd)// FFT変換、逆変換　精度確認
        {
            for (int j = nini; j <= nend; j++)
            {
                a[j] = rnd;
            }
        }
        // 一木裕貴　Javaによる音のFourier解析　大浦 FFT の書き換え　テストプログラムの実行
        private double Errorcheck(int nini, int nend, double scale, double[] a, double rnd)
        {
            int j;
            double err, e;
            err = 0;

            for (j = nini; j <= nend; j++)
            {
                e = rnd - a[j] * scale;
                if (Math.Abs(e) >= err)
                {
                    err = Math.Abs(e);
                }
            }
            return err;
        }
        //  FFT精度比較　rnd→Original's FFT vs rnd→Ooura's FFT
        private double CompareFFTresult(int nini, int nend, double[] FftReal, double[] FftImag, double[] a)
        {
            double err, e;
            err = 0;

            for (int j = nini; j <= nend; j++)
            {
                int k = j << 1; // =  int k = j * 2;
                e = FftReal[j] - a[k];
                if (Math.Abs(e) >= err)
                {
                    err = Math.Abs(e);
                }
                e = FftImag[j] - a[k+1];
                if (Math.Abs(e) >= err)
                {
                    err = Math.Abs(e);
                }
            }
            return err;
        }
        //
        // 信号処理スレッド
        //
        private void SignalWork(object sender, DoWorkEventArgs e)
        {
            // SDR処理のエリア確保など
            Int16[] SoundData = new Int16[2048];    // サウンドカードとやりとりするデータ用のバッファ
            double[] SignalReal = new double[1024]; // Signal data (1024 samples)
            double[] SignalImag = new double[1024]; // Imag data (1024 samples)
            double[] LocalReal = new double[1024];  // Local signal (real)
            double[] LocalImag = new double[1024];  // Local signal (imag)
            double[] FftReal = new double[1024];    // FFT計算用のバッファ(real)
            double[] FftImag = new double[1024];    // FFT計算用のバッファ(imag)
            double[] Spectrum = new double[1024];   // スペクトラム表示するデータ(dB単位);

            // for fft8g
            int n, n2, n2sqrt;
            int[] ip;
            double[] a, w;

            // set parameter value for Ooura's fft8g
            // http://www.kurims.kyoto-u.ac.jp/~ooura/fft-j.html
            // fft8g ソースプログラムの33～71行（関数使用方法の説明）に着目
            n = 1024;    // n組（組=:実数と複素数）
            n2 = 2048;   // n * 2
            n2sqrt = 46; // >=SQRT(n2)
            ip = new int[n2sqrt + 2];
            a = new double[n2];
            w = new double[n / 2];
            ip[0] = 0; // w[],ip[] are initialized if ip[0] == 0
            // finish parameter value for fft8g

            // FFT変換、逆変換　精度確認処理
            // 一木裕貴　Javaによる音のFourier解析　大浦 FFT の書き換え　テストプログラムの実行 精度テスト
            System.Random r = new System.Random(1000);
            double p = r.NextDouble();
            double rnd = ((p * 7141 + 54773) % 259200) * (1.0 / 259200.0);
            Putdata(0, n2 - 1, a, rnd);
            // richTextBox1.Text += "cdft A rnd="+ rnd.ToString(@"G") + " a[0]=" + a[0].ToString(@"G") + " a[1]=" + a[1].ToString(@"G") + " a[6]=" + a[6].ToString(@"G") + " a[7]=" + a[7].ToString(@"G") + "\r\n"; // FFT精度確認 誤差出力
            Fft8g.cdft(n2, 1, a, ip, w); // cdft(2046, 1, a[2049個], ip[48個], w[2560個]); // n組　FFT変換
            // richTextBox1.Text += "cdft B" + " a[0]=" + a[0].ToString(@"G") + " a[1]=" + a[1].ToString(@"G") + " a[6]=" + a[6].ToString(@"G") + " a[7]=" + a[7].ToString(@"G") + "\r\n"; // FFT精度確認 誤差出力
            Fft8g.cdft(n2, -1, a, ip, w);                                                  // n組　FFT逆変換
            // richTextBox1.Text += "cdft C" + " a[0]=" + a[0].ToString(@"G") + " a[1]=" + a[1].ToString(@"G") + " a[6]=" + a[6].ToString(@"G") + " a[7]=" + a[7].ToString(@"G") + "\r\n"; // FFT精度確認 誤差出力
            double err = Errorcheck(0, n2 - 1, 1.0 / n, a, rnd);                           // FFT精度確認
            if(err != 0.0) richTextBox1.Text += "cdft errMax = " + err.ToString(@"G") + "\r\n";                       // FFT精度確認 誤差出力
            
            // FFT精度比較　rnd→Original's FFT vs rnd→Ooura's FFT
            Putdata(0, n2 - 1, a, rnd);
            Fft8g.cdft(n2, 1, a, ip, w); // cdft(2046, 1, a[2049個], ip[48個], w[2560個]); // n組　FFT変換            
            for (int i = 0; i < n; i++)
            {
                FftImag[i] = rnd;
                FftReal[i] = rnd;
            }
            fft.GetFft(FftReal, FftImag, false); // Original FFT を行う  順方向のFFTを行い周波数成分(複素数)を得る
            err = CompareFFTresult(0, n -1, FftReal, FftImag, a);
            if (err != 0.0) richTextBox1.Text += "two FFT errMax = " + err.ToString(@"G") + "\r\n";                  // FFT精度確認 誤差出力

            // サウンドカード設定
            SoundCard.WaveFormatSetup(16000);   // サウンドカードのサンプル周波数を16KHzに設定
            if(SoundCard.SetupInBuffer() != 0)  // サウンドデータを受け取るリングバッファを設定
                MessageBox.Show("入力デバイスの初期化に失敗しました");
            if(SoundCard.SetupOutBuffer() != 0) // サウンドデータを出力するリングバッファを設定
                MessageBox.Show("出力デバイスの初期化に失敗しました");
            SoundCard.StartCapture();   // サウンドカードのサンプリング動作を開始する

            while(!abortflag)   // 中断フラグが立つまで無限に続ける
            {
                if(SoundCard.CheckQueue() != 0)    // サウンドデータが揃ったら信号処理を始める
                {
                    //
                    //  サウンドカードまたはファイルからの入力
                    //
                    SoundCard.GetRecData(SoundData); // 16ビットのサウンドデータをサウンドカードから取得する
                    SoundCard.SoundToFloat(SignalReal, SignalImag, SoundData, GetTextValue(textBox3));  // 無条件にサウンドデータから浮動小数点に変換する
                    // if (radioButton4.Checked)        // スペクトラム表示はライン入力を表示する指定か？
                    // { Array.Copy(SignalReal, FftReal, 1024); Array.Copy(SignalImag, FftImag, 1024); }// ライン入力信号を保存
                    //
                    //  入力セレクタの処理
                    //
                    if(FileMode)                    // ファイルモードなら
                    {
                        FileMode = wave.ReadWaveFile(FileName, SoundData);  // ファイルから信号データを取得する
                        SoundCard.SoundToFloat(SignalReal, SignalImag, SoundData, GetTextValue(textBox3));  // WAVEファイルから浮動小数点に変換する
                    }
                    /*
                    if(radioButton11.Checked)   //  発振器が指定されてるか？
                    {
                        if(radioButton18.Checked)   // 変調がオフなら単なる発振器として動作
                            osc1.CreateSignal(SignalReal, SignalImag, GetTextValue(textBox1), GetTextValue(textBox3));   // 複素信号を発生させる
                        else // 変調が指定されているなら
                        {
                            Array.Copy(SignalReal, LocalReal, 1024);    // 入力信号の実部だけを取り出し保存する
                            osc1.CreateSignal(SignalReal, SignalImag, GetTextValue(textBox1), 0.1);   // -20dBのキャリアを作成する
                            if(radioButton19.Checked)   // AM変調が指定されているか？
                                signal.AmMod(SignalReal, SignalImag, LocalReal);   // キャリアを振幅変調する
                            else  // FM変調が指定されているか？
                                signal.FmMod(SignalReal, SignalImag, LocalReal);   // キャリアを周波数変調する
                        }
                    }
                    if(radioButton13.Checked)   //  ノイズジェネレータが指定されているか？
                        signal.CreateNoise(SignalReal, SignalImag, GetTextValue(textBox3));
                    */
                    if (checkBox2.Checked)  // I/Qリバースが指定されているか？
                        signal.SwapData(SignalReal, SignalImag);    // I/Qデータを入れ替える
                    // if(radioButton5.Checked)        // スペクトラム表示はセレクタ出力を表示する指定か？
                    { Array.Copy(SignalReal, FftReal, 1024); Array.Copy(SignalImag, FftImag, 1024); }// セレクタ出力信号を保存                    
                    //
                    //  第1ミクサの処理
                    //
                    //if (checkBox3.Checked)   // 第1ミキサはONか？
                    {
                        freq = (double)GetTextValue(textBox5) / 1000;   // 受信周波数を求める
                        osc2.CreateSignal(LocalReal, LocalImag, GetTextValue(textBox4) * (checkBox5.Checked ? -1 : 1), 1.0);  // 局部発振を作成する
                        signal.MultiplySignal(SignalReal, SignalImag, LocalReal, LocalImag);    // 掛け算して周波数変換を行なう
                        cursor = 10.0;  // まずカーソル表示はデフォルトでOFFにする(10.0は常に表示範囲外)
                        // if (radioButton5.Checked && checkBox5.Checked)    // FFT表示が入力信号でリバースなら赤チューニングカーソルを表示する
                        if (checkBox5.Checked)    // FFT表示が入力信号なら赤チューニングカーソルを表示する
                            cursor = freq;   // チューニングカーソルを表示するため周波数を指定する                        
                    }
                    // if (radioButton6.Checked)        // スペクトラム表示はミキサ出力を表示する指定か？
                    // { Array.Copy(SignalReal, FftReal, 1024); Array.Copy(SignalImag, FftImag, 1024); }// ミキサ出力を保存
                    //
                    //  フィルタの処理
                    //
                    filter.FirFilter(SignalReal, SignalImag);   // FIRフィルタを適用する
                    // if(radioButton7.Checked)        // スペクトラム表示はフィルタ出力を表示する指定か？
                    //{ Array.Copy(SignalReal, FftReal, 1024); Array.Copy(SignalImag, FftImag, 1024); }// フィルタ出力を保存                    
                    //
                    //  第2ミクサ(Beat Frequency Oscillator)の処理
                    //
                    if (osc2on)   // 第2ミキサはONか？
                    {
                        osc3.CreateSignal(LocalReal, LocalImag, GetTextValue(textBox10), 1.0);  // 局部発振(BFO)を作成する
                        signal.MultiplySignal(SignalReal, SignalImag, LocalReal, LocalImag);    // 掛け算して周波数変換を行なう
                    }
                    level = signal.GetAbs(null, SignalReal, SignalImag);    // このパケット内で最大の信号強度を求める
                    if(checkBox8.Checked)   // AGCは有効か？
                        signal.ApplyAgc(SignalReal, SignalImag, level);    // AGC処理を行なう
                    // if(radioButton8.Checked)        // スペクトラム表示は第2ミキサ出力を表示する指定か？
                    // { Array.Copy(SignalReal, FftReal, 1024); Array.Copy(SignalImag, FftImag, 1024); }// 第2ミキサ出力を保存                    
                    //
                    //  検波の処理
                    //
                    if(radioButton14.Checked)    // LSBモードか
                    {   // すでにBFOで振幅成分が得られているのでなにもしない
                    }
                    else if (radioButton21.Checked)    // USBモードか
                    {   // すでにBFOで振幅成分が得られているのでなにもしない
                    }
                    else if (radioButton15.Checked)    // AMモードか
                    {
                        signal.GetAbs(SignalReal, SignalReal, SignalImag);  // AMなら振幅成分を取り出す
                        signal.MulConst(SignalReal, SignalImag, 3.16);      // 他のモードの出力と揃える為10dB増幅する
                    }
                    // 実信号化
                    Array.Copy(SignalReal, SignalImag, 1024);   // 得られた振幅成分を虚部にもコピーして実信号化する

                    // if(radioButton9.Checked)        // スペクトラム表示は検波出力を表示する指定か？
                    // { Array.Copy(SignalReal, FftReal, 1024); Array.Copy(SignalImag, FftImag, 1024); }// 検波出力を保存 
                    //
                    //  サウンド出力
                    //
                    signal.MulConst(SignalReal, SignalImag, checkBox1.Checked ? 0 : afgain);    // ミュート時には0を、それ以外はafgainを掛ける
                    SoundCard.FloatToSound(SoundData, SignalReal, SignalImag); // 浮動小数点からサウンドデータに変換
                    if(silent)  // 画面が消えていたら無音にする
                        Array.Clear(SoundData, 0, 2048);    // サウンドデータをクリア
                    SoundCard.PutPlayData(SoundData);    // サウンドデータをサウンドカードに出力する                    
                    //
                    //  スペクトラム表示
                    //
                    fft.ApplyWindow(FftReal, FftImag);   // 信号に窓関数を適用する

                    if (radioButton24.Checked) // Original FFT
                    {                        
                        fft.GetFft(FftReal, FftImag, false); // Original FFT を行う  順方向のFFTを行い周波数成分(複素数)を得る
                    }
                    if (radioButton25.Checked) // fft8g FFT
                    {
                        for (int i = 0; i < n; i++)
                        {
                            int j = i << 1; // =  int j = i * 2;
                            // int j = i * 2;
                            a[j] = FftImag[i];
                            a[j + 1] = FftReal[i];
                        }
                        Fft8g.cdft(2048, 1, a, ip, w); // cdft(2048, 1, a[2049個], ip[47個], w[2560個]);
                        for (int i = 0; i < n; i++)
                        {
                            int j = i << 1; // =  int j = i * 2;
                            FftImag[i] = a[j];
                            FftReal[i] = a[j + 1];
                        }
                    }
                    fft.GetDecibel(Spectrum, FftReal, FftImag); // 複素数の絶対値をdB値に変換する
                    sp.Display(grfx, wfgrfx, bmpWf, Spectrum, GetDispStyle(), cursor, track3Value, track4Value, track5Value, track6Value, filDispWidth); // スペクトラムとWF表示をアップデートする
                    try { pictureBox1.Refresh(); }              // スペクトラム表示画面を更新する
                    catch { };  // 画面更新の際にエラーが起きた際の受け皿(実際には発生しない)
                    try { pictureBox2.Refresh(); }              // スペクトラム表示画面を更新する
                    catch { };  // 画面更新の際にエラーが起きた際の受け皿(実際には発生しない)
                }
                System.Threading.Thread.Sleep(10);   // 他のスレッドが動作できるようにOSに制御を返す
            }
            if(FileMode)    // ファイル入力モードに設定されていたなら
                wave.CloseWaveFile();   // ファイルをクローズする
            SoundCard.HeapCleanUp();    // 信号処理スレッドを抜けたのでサウンドカードを閉じる
            abortflag = false;  // スレッドが終了した事を親スレッドに伝える
        }
        //
        //  FFTの窓関数が変更された際の処理
        //
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (fft != null)   //　FFTクラスが生成済みなら
                fft.SetupWindow(comboBox1.SelectedIndex);    // 窓関数を変更する
        }
        //
        //  ファイルモードが選択された際の処理
        //
        private void radioButton12_CheckedChanged(object sender, EventArgs e)
        {
            if(radioButton12.Checked)   // ファイルモードが選択されたか？
            {
                FileName = textBox2.Text + ".wav";  // WAVEファイル名を生成
                FileMode = true;    // ファイルモードフラグをセット
            }
            else
            {   // ファイルモードではなくなった場合
                wave.CloseWaveFile();   // 現在オープンしているファイルをクローズする
                FileMode = false;   // ファイルモードフラグをクリアする
            }
        }
        //
        //  トラックバー(ボリューム用)が動かされたら
        //
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            // afgain = (double)trackBar1.Value / trackBar1.Maximum;   // AFゲインを設定する
            afgain = (double)trackBar1.Value;   // AFゲインを設定する
        }

        //  トラックバー(チューニング用)が動かされた時の処理
        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            trackBar2_Sc();
            SetFilterWidth(); // スペクトラムに表示するフィルタ幅を設定
        }
        private void trackBar2_Sc()
        {
            TrackValue = trackBar2.Value;   //　トラックバーの値 0～256 を得る
            // if (checkBox4.Checked)       // スライダーのチェックが付けられていれば
            {
                textBox5.Text = (TrackValue * 16000 / 256 - 8000).ToString();// 受信周波数を上書きする -8000～8000
                SetTextBox4(); // 第1局発周波数をセット 
                cursor = GetTextValue(textBox5);   // 受信周波数カーソルを表示するため周波数を指定する
            }
        }

        //  トラックバー(入力信号レベル調整)が動かされた時の処理
        private void trackBar9_Scroll(object sender, EventArgs e)
        {
            if(trackBar9.Value == trackBar9.Minimum){ textBox3.Text = "0.01"; }
            else { textBox3.Text = (trackBar9.Value * 0.1).ToString(); }  //　
        }
        //  トラックバー(下限周波数)が動かされた時の処理
        private void trackBar7_Scroll(object sender, EventArgs e)
        {
            filterLow = trackBar7.Value * 50;
            textBox9.Text = filterLow.ToString();   //　
            SetupFilter();  // フィルタ設定を反映する
        }
        //  トラックバー(上限周波数)が動かされた時の処理
        private void trackBar8_Scroll(object sender, EventArgs e)
        {
            filterHigh = trackBar8.Value * 100;
            if(filterLow < filterHigh)
            {
                textBox8.Text = filterHigh.ToString();   //　
                SetupFilter();  // フィルタ設定を反映する
                if (radioButton14.Checked == true) textBox10.Text = "-" + textBox8.Text; // LSB
                else if (radioButton21.Checked == true) textBox10.Text = textBox8.Text;  // USB
            }
        }
        //  トラックバー(スペクトラム濃淡用)が動かされた時の処理
        private void trackBar3_Scroll(object sender, EventArgs e)
        {
//            track3Value = trackBar3.Value;   //　
        }
        //  トラックバー(スペクトラム明るさ用)が動かされた時の処理
        private void trackBar4_Scroll(object sender, EventArgs e)
        {
            track4Value = trackBar4.Value;   //　
        }
        //  トラックバー(WF濃淡用)が動かされた時の処理
        private void trackBar5_Scroll(object sender, EventArgs e)
        {
            track5Value = trackBar5.Value;   //　
        }
        //  トラックバー(WF明るさ用)が動かされた時の処理
        private void trackBar6_Scroll(object sender, EventArgs e)
        {
            track6Value = trackBar6.Value;   //　
        }

        //
        //  入力ファイル名が変更されたら
        //
        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            radioButton10.Checked = true;   // 入力を一旦ライン入力に変更する
        }
        //
        //  第二局発周波数が変更されたら
        //
        private void textBox10_TextChanged(object sender, EventArgs e)
        {
            SetTextBox4(); // 第1局発周波数をセット 
        }
        //　検波LSBのチェックボックスがチェックされた時の処理
        private void radioButton14_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton14.Checked)
            {
                //textBox5.Text = "0";
                //textBox8.Text = ssbFilterHigh;
                //textBox9.Text = ssbFilterLow;
                filterHigh = ssbFilterHigh;
                textBox8.Text = filterHigh.ToString();
                filterLow = ssbFilterLow;
                textBox9.Text = filterLow.ToString();
                trackBar7.Value = 2;
                trackBar8.Value = 15;
                SetupFilter();
                textBox10.Text = "-" + textBox8.Text;
                osc2on = true;
                // BFO周波数分だけずらした値を第１OSC周波数とする
                try { textBox4.Text = (GetTextValue(textBox5) + (osc2on ? GetTextValue(textBox10) : 0)).ToString(); }// 第１OSC周波数
                catch (InvalidOperationException) { }  // エラーがあればここへ(実際は来ない)
            }
        }
        //　検波USBのチェックボックスがチェックされた時の処理
        private void radioButton21_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton21.Checked)
            {
                //textBox5.Text = "0";
                filterHigh = ssbFilterHigh;
                textBox8.Text = filterHigh.ToString();
                filterLow = ssbFilterLow;
                textBox9.Text = filterLow.ToString();
                trackBar7.Value = 2;
                trackBar8.Value = 15;
                SetupFilter();
                textBox10.Text = textBox8.Text;
                osc2on = true;
                // BFO周波数分だけずらした値を第１OSC周波数とする
                try { textBox4.Text = (GetTextValue(textBox5) + (osc2on ? GetTextValue(textBox10) : 0)).ToString(); }// 第１OSC周波数
                catch (InvalidOperationException) { }  // エラーがあればここへ(実際は来ない)
            }
        }
        //　検波CWRのチェックボックスがチェックされた時の処理
        private void radioButton22_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton22.Checked)
            {
                filterHigh = cwFilterHigh;
                textBox8.Text = filterHigh.ToString();
                filterLow = cwFilterLow;
                textBox9.Text = filterLow.ToString();
                trackBar7.Value = 0;
                trackBar8.Value = 3;
                SetupFilter();
                textBox10.Text = "-" + cwToneFreq;
                osc2on = true;
                // BFO周波数分だけずらした値を第１OSC周波数とする
                try { textBox4.Text = GetTextValue(textBox5).ToString(); }// 第１OSC周波数
                catch (InvalidOperationException) { }  // エラーがあればここへ(実際は来ない)
            }
        }
        //　検波CWのチェックボックスがチェックされた時の処理
        private void radioButton23_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton23.Checked)
            {
                filterHigh = cwFilterHigh;
                textBox8.Text = filterHigh.ToString();
                filterLow = cwFilterLow;
                textBox9.Text = filterLow.ToString();
                trackBar7.Value = 0;
                trackBar8.Value = 3;
                SetupFilter();
                textBox10.Text = cwToneFreq;
                osc2on = true;
                // BFO周波数分だけずらした値を第１OSC周波数とする
                try { textBox4.Text = GetTextValue(textBox5).ToString(); }// 第１OSC周波数
                catch (InvalidOperationException) { }  // エラーがあればここへ(実際は来ない)
            }
        }

        //　検波AMのチェックボックスがチェックされた時の処理
        private void radioButton15_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton15.Checked)
            {
                filterHigh = amFilterHigh;
                textBox8.Text = filterHigh.ToString();
                filterLow = amFilterLow;
                textBox9.Text = filterLow.ToString();
                trackBar7.Value = 0;
                trackBar8.Value = 40;
                SetupFilter();
                textBox10.Text = "";
                osc2on = false;
            }
        }

        //
        //  前回の受信動作条件設定
        //
        private void button3_Click(object sender, EventArgs e)
        {
            restart();
        }
        //　
        //  ワンタッチで出荷時に戻す
        //
        private void button4_Click(object sender, EventArgs e)
        {
            trackBar9.Value = 1;   // 入力レベル
            textBox3.Text = (trackBar9.Value * 0.1).ToString();
            trackBar2.Value = 192;  // 4000Hzの位置に
            //trackBar3.Value = 10;  // スペクトラム濃淡
            trackBar4.Value = 10;  // スペクトラムバイアス
            trackBar5.Value = 10;  // WF濃淡
            trackBar6.Value = 7;  // WF明暗
            trackBar7.Value = 0;   // フィルタ下限周波数
            trackBar8.Value = 15;  // フィルタ上限周波数
            trackBar1.Value = 1;   // モニタ音ボリューム位置
            afgain = (double)trackBar1.Value;

            inputKind = 12;         // File
            textBox2.Text = "7m";   // 受信ファイル名
            textBox4.Text = "2500"; // 第一局発周波数
            textBox5.Text = "4000"; // 目的周波数
            textBox8.Text = "1500"; // 上限周波数
            textBox9.Text = "0";    // 下限周波数
            textBox10.Text = "-1500";   // BFO周波数（第二局発周波数）
            radioButton3.Checked = true; // -8KHzから8kHz表示モードに
            radioButton12.Checked = true;// ファイルを指定
            radioButton14.Checked = true;// LSBモード
            checkBox1.Checked = false;   // ミュートOFF
            checkBox2.Checked = false;   // リバースOFF
            checkBox5.Checked = true;    // リバースON
            osc2on = true;   // 第2ミクサON
            checkBox8.Checked = true;   // AGC ON
            comboBox1.SelectedIndex = 2;    // FFT窓関数をBlackmannに指定                                            
            SetupFilter(); // trackBar設定を反映する
            track4Value = trackBar4.Value; // trackBar設定を反映する　
            track5Value = trackBar5.Value; // trackBar設定を反映する　
            track6Value = trackBar6.Value; // trackBar設定を反映する
        }
    }

    class Spectrum  // スペクトラム表示をするクラス
    {
        // カラー リファレンス
        // https://csharp-ref.com/drawing_color.html
        Pen scale = new Pen(Color.LightGreen); //目盛線の色
        Pen carrFreq = new Pen(Color.Red); //現在周波数（キャリア位置）の色
        Pen penSpectrum = new Pen(Color.White);
        Pen outFilter = new Pen(Color.Brown);

        SolidBrush charact = new SolidBrush(Color.White);
        SolidBrush inFilter = new SolidBrush(Color.MediumBlue);
        Font font = new Font("MS UI Gothic", 8);

        int spectrumHight = 100;
        int bias = 0;  // スペアナ、ウォーターフォール表示の際のレベル調整値

        string ff;
        string color;
        int leftStrongeth;
        Rectangle srcRect = new Rectangle(0, 0, 512, 199);
        Rectangle desRect = new Rectangle(0, 1, 512, 199);

        //
        //  スペクトラムアナライザの描画
        //
        public void Display(Graphics grfx, Graphics wfgrfx, Bitmap bmpWf, double[] spectrum, int style, double cursor, int track3, int track4, int track5, int track6, bool[] filDispWidth)
        {
            int i, j;

            //wfgrfx.FillRectangle(outFilterBrush, 0, 0, 512, 200);  // WF画面をバック色でクリア　この行を生かすと希望とおりの動作しない
            grfx.FillRectangle(inFilter, 0, 0, 512, 100);  // スペクトラム画面をフィルタ範囲内の色で埋めておく
            if (style == 0)
            {   // 0KHzから8KHz表示モード？
                for (i = 0; i < 512; i++)    // 右半分    ～　4KHzまで1周波数スペクトル毎
                {
                    if (filDispWidth[i] == false)
                    {
                        grfx.DrawLine(outFilter, i, 0, i, spectrumHight);   //フィルタ範囲外の色を縦線で描画
                    }
                }

                for (i = 1; i < 8; i++)  // dB表示の縦線を描画する
                {
                    grfx.DrawString((i - ((style == 1) ? 4 : 0)).ToString() + "k", font, charact, i * 64 - 8, spectrumHight - 9);//周波数を表示
                    grfx.DrawLine(scale, i * 64, 0, i * 64, spectrumHight - 10);// 目盛線を描く
                }
                for (i = 1; i < 9; i++)  // dB表示の横線を描画する
                {
                    grfx.DrawString("-" + (i * 10).ToString() + "dB", font, charact, 480, i * 20 - 6);//dB表示を右側に
                    grfx.DrawLine(scale, 0, i * 20, 480, i * 20);   // 目盛線を描く
                }

                for (i = 0; i < 512; i++)
                {
                    j = (int)(spectrum[i] * 2 + bias);  // 表示座標を得る
                    //if (j > 0)   // 表示範囲か？
                    {
                        // grfx.DrawLine(pen, i, 180, i, 180 - j);//そうならマゼンタで描画する
                        DrawSpectrum(grfx, i, j, track3, track4); // DrawSpectrum(Graphics grfx, x1, j, track3, track4)
                        DrawWaterFall(wfgrfx, i, j, track5, track6);
                    }
                }
                if (cursor > 0 && cursor < 8.0)  // 表示範囲内にカーソルがあるか？
                    grfx.DrawLine(carrFreq, (int)(cursor * 64), spectrumHight, (int)(cursor * 64), 0); //そうなら描画する

                wfgrfx.DrawImage(bmpWf, desRect, srcRect, GraphicsUnit.Pixel);
            }
            else if (style == 1)
            {   // -4KHzから4KHz表示モード
                // 左半分 -4KHzから0Hzまで
                for (i = 0; i < 256; i++)    // 左半分 -4KHzから0まで1周波数スペクトル毎
                {
                    if (filDispWidth[i + 768] == false)
                    {
                        grfx.DrawLine(outFilter, i, 0, i, spectrumHight);    //フィルタ範囲外の色を縦線で描画
                    }
                }
                for (i = 1; i < 8; i++)  // dB表示の縦線を描画する
                {
                    grfx.DrawString((i - ((style == 1) ? 4 : 0)).ToString() + "k", font, charact, i * 64 - 8, spectrumHight - 9);//周波数を表示
                    grfx.DrawLine(scale, i * 64, 0, i * 64, spectrumHight-10);// 目盛線を描く
                }
                for (i = 1; i < 9; i++)  // dB表示の横線を描画する
                {
                    grfx.DrawString("-" + (i * 10).ToString() + "dB", font, charact, 480, i * 20 - 6);//dB表示を右側に
                    grfx.DrawLine(scale, 0, i * 20, 480, i * 20);   // 目盛線を描く
                }

                for (i = 0; i < 256; i++)    // 左半分 -4KHzから0まで1周波数スペクトル毎
                {
                    j = (int)(spectrum[i + 768] * 2);    // 強度（表示範囲）を得る
                    //if (j > 0)// 表示範囲か？
                    {
                        DrawSpectrum(grfx, i, j, track3, track4); // DrawSpectrum(Graphics grfx, x1, j, track3, track4)
                        DrawWaterFall(wfgrfx, i, j, track5, track6);
                    }
                }

                // 右半分    ～　4KHzまで
                for (i = 0; i < 256; i++)    // 右半分    ～　4KHzまで1周波数スペクトル毎
                {
                    if (filDispWidth[i] == false)
                    {
                        grfx.DrawLine(outFilter, i + 256, 0, i + 256, spectrumHight);   //フィルタ範囲外の色を縦線で描画
                    }
                }

                for (i = 1; i < 8; i++)  // dB表示の縦線を描画する
                {
                    grfx.DrawString((i - ((style == 1) ? 4 : 0)).ToString() + "k", font, charact, i * 64 - 8, spectrumHight - 9);//周波数を表示
                    grfx.DrawLine(scale, i * 64, 0, i * 64, spectrumHight - 10);// 目盛線を描く
                }
                for (i = 1; i < 9; i++)  // dB表示の横線を描画する
                {
                    grfx.DrawString("-" + (i * 10).ToString() + "dB", font, charact, 480, i * 20 - 6);//dB表示を右側に
                    grfx.DrawLine(scale, 0, i * 20, 480, i * 20);   // 目盛線を描く
                }

                for (i = 0; i < 256; i++)    // 右半分 ～　4KHzまで1周波数スペクトル毎
                {
                    j = (int)(spectrum[i] * 2);    // 強度（表示範囲）を得る
                    //if (j >= 0) // 表示範囲か？
                    {
                        DrawSpectrum(grfx, i + 256, j, track3, track4); // DrawSpectrum(Graphics grfx, x1, j, track3, track4)
                        DrawWaterFall(wfgrfx, i + 256, j, track5, track6);
                    }                    
                }
                if (Math.Abs(cursor) < 4.0)  // 表示範囲内にカーソルがあるか？
                    grfx.DrawLine(carrFreq, (int)(cursor * 64 + 256), spectrumHight, (int)(cursor * 64 + 256), 0);//そうなら描画する

                wfgrfx.DrawImage(bmpWf, desRect, srcRect, GraphicsUnit.Pixel);
            }
            else // style == 2
            {   // -8Kから8K表示モード
                // 左半分 -8KHzから0Hzまで
                for (i = 0; i < 256; i++)    // 左半分 -4KHzから0まで1周波数スペクトル毎
                {
                    if (filDispWidth[i * 2 + 512] == false)
                    {
                        grfx.DrawLine(outFilter, i, 0, i, spectrumHight);   //フィルタ範囲外の色を縦線で描画
                    }
                }
                for (i = 1; i < 16; i++)  // dB表示の縦線を描画する
                {
                    grfx.DrawString((i - 8).ToString() + "k", font, charact, i * 32 - 8, spectrumHight - 9);//周波数を表示
                    grfx.DrawLine(scale, i * 32, 0, i * 32, spectrumHight - 10);// 目盛線を描く
                }
                for (i = 1; i < 9; i++)  // dB表示の横線を描画する
                {
                    grfx.DrawString("-" + (i * 10).ToString() + "dB", font, charact, 480, i * 20 - 6);//dB表示を右側に
                    grfx.DrawLine(scale, 0, i * 20, 480, i * 20);   // 目盛線を描く
                }

                for (i = 0; i < 256; i++)    // 左半分
                {
                    j = (int)(spectrum[i * 2 + 512] + spectrum[i * 2 + 513] + bias);// 表示範囲を得る(2点の平均を求める)
                    //j = (int)(spectrum[i * 2 + 512] *2 + bias);// 表示範囲を得る(2倍)
                    //if (j > 0)// 表示範囲か？
                    {
                        DrawSpectrum(grfx, i, j, track3, track4); // DrawSpectrum(Graphics grfx, x1, j, track3, track4)
                        DrawWaterFall(wfgrfx, i, j, track5, track6);
                    }
                }

                // 右半分    ～-8KHzまで
                for (i = 0; i < 256; i++)    // 右半分    ～-8KHzまで1周波数スペクトル毎
                {
                    if (filDispWidth[i * 2] == false)
                    {
                        grfx.DrawLine(outFilter, i + 256, 0, i + 256, spectrumHight);   //フィルタ範囲外の色を縦線で描画
                    }
                }
                for (i = 1; i < 16; i++)  // dB表示の縦線を描画する
                {
                    grfx.DrawString((i - 8).ToString() + "k", font, charact, i * 32 - 8, spectrumHight - 9);//周波数を表示
                    grfx.DrawLine(scale, i * 32, 0, i * 32, spectrumHight - 10);// 目盛線を描く
                }
                for (i = 1; i < 9; i++)  // dB表示の横線を描画する
                {
                    grfx.DrawString("-" + (i * 10).ToString() + "dB", font, charact, 480, i * 20 - 6);//dB表示を右側に
                    grfx.DrawLine(scale, 0, i * 20, 480, i * 20);   // 目盛線を描く
                }

                for (i = 0; i < 256; i++)    // 右半分
                {
                    j = (int)(spectrum[i * 2] + spectrum[i * 2 + 1] + bias);// 表示範囲を得る(2点の平均を求める)
                    //if (j > 0)// 表示範囲か？
                    {
                        DrawSpectrum(grfx, i + 256, j, track3, track4); // DrawSpectrum(Graphics grfx, x1, j, track3, track4)
                        DrawWaterFall(wfgrfx, i + 256, j, track5, track6);
                    }
                }
                if (Math.Abs(cursor) < 8.0)  // 表示範囲内にカーソルがあるか？
                    grfx.DrawLine(carrFreq, (int)(cursor * 32 + 256), spectrumHight, (int)(cursor * 32 + 256), 0);//そうなら描画する

                wfgrfx.DrawImage(bmpWf, desRect, srcRect, GraphicsUnit.Pixel);
            }
            grfx.DrawLine(scale, 0, spectrumHight, 512, spectrumHight); // グラフの一番下の線を描く
        }

        // スペクトラム描画　直前の0でないxy座標から現在のxy座標へ線を描く
        private void DrawSpectrum(Graphics grfx, int x1, int j, int darkness, int bright) // DrawSpectrum(graphic, 現在の描画x座標, 信号強度FFT値, darkness, bright)
        {   // track3:濃淡:0～20  track4:明るさ:0～20
            int k;
            k = j  + bright * 3; // track3:濃淡:0～20  track4:明るさ:0～20
            if (k >= spectrumHight) k = spectrumHight;
            if (x1 == 0)
            {
                leftStrongeth = k;
            }
            else
            {
                grfx.DrawLine(penSpectrum, x1 - 1, spectrumHight - leftStrongeth, x1, spectrumHight - k); // 包絡線を描く
                if (j != 0) leftStrongeth = k;
            }
        }

        // WaterFall描画
        private void DrawWaterFall(Graphics wfgrfx, int x1, int j, int darkness, int bright) // DrawWaterFall(graphic, 描画x座標, 信号強度FFT値, darkness, bright)
        {
            Pen wfPen = new Pen(Color.Black);
            double k; int i;
            k = (j + bright * 5 ) * darkness / 32; // track3:darkness濃淡:0～20  track4:bright明るさ:0～20

            if (k < 1) k = 1;     // 濃さ範囲か？
            else if (k > 255) k = 255; // 濃さ範囲か？
            i = (Int16)k;
            ff = Convert.ToString(i, 16); // 16進表記への変換
            color = "#" + ff + ff + ff;
            wfPen.Color = ColorTranslator.FromHtml(color);
            wfgrfx.DrawLine(wfPen, x1, 0, x1, 0 + 0.1F);
        }
    }

    class WaveFile  // WAVEファイルを扱うクラス
    {
        byte[] ch = new byte[4];    // 4バイトの検索用バッファ
        BinaryReader br; // バイナリリーダクラスオブジェクトを作成
        int datalen;    // WAVEデータの長さ
        //
        //  WAVEファイルをオープンする
        //
        public bool SetupWaveFile(String FileName)
        {
            try
            {
                br = new BinaryReader(File.OpenRead(FileName));// ファイルを開いてみる
            }
            catch (FileNotFoundException)    // 見つからなければ
            {
                br = null;   // ファイルが見つからない？
                return false;    //　エラーで帰る
            }
            for (; ; )
            {
                try
                {
                    ch[3] = br.ReadByte();   // 1バイト読む
                }
                catch (EndOfStreamException)
                {
                    return CloseWaveFile(); // もう読めなければファイルを閉じてエラーで帰る
                }
                if (ch[0] == 'd' && ch[1] == 'a' && ch[2] == 't' && ch[3] == 'a')// dataという4文字が見つかったか？
                    break;  // 見つかったらループを抜ける
                ch[0] = ch[1]; ch[1] = ch[2]; ch[2] = ch[3];    // 一文字ずつずらす
            }
            datalen = br.ReadInt32();    // WAVEデータの長さを読み込む
            datalen -= datalen % 4096;  // 4096単位でしかアクセスしないので長さを切りそろえる
            if (datalen == 0)    // ファイルが短いならエラーで帰る
                return CloseWaveFile(); // ファイルをクローズしてエラーで帰る
            return true;   // 成功リターン
        }
        //
        //  WAVEファイルからデータを読み込む
        //
        public bool ReadWaveFile(String filename, Int16[] buf)
        {
            Array.Clear(buf, 0, 2048); // まずバッファをクリア
            if (br == null)   // オープンされていない？
            {
                if (!SetupWaveFile(filename))    // オープンを試みる
                    return false;    // 見つからなければエラーリターン
            }
            for (int i = 0; i < 2048; i++)   // 1024サンプル取り出す
            {
                try
                {
                    buf[i] = br.ReadInt16(); // 16ビットずつ読み込む
                }
                catch (EndOfStreamException)
                {
                    return CloseWaveFile(); // エラー終了
                }
            }
            datalen -= 4096;    // データ長を減算する
            if (datalen == 0)    // 最終データを読み込んだか？
            {
                CloseWaveFile();    // ファイルをクローズして
                return SetupWaveFile(filename);    // 再度オープンを試みる
            }
            return true;   // 正常終了
        }
        //
        //  WAVEファイルをクローズする
        //
        public bool CloseWaveFile()
        {
            if (br != null)   // バイナリリーダが存在してるなら
                br.Close();  // クローズする
            br = null;       // もうbrは空なので検出用にnullにしておく
            return false;   // 常にfalseで帰る(エラーリターンに利用)
        }
    }
    class SoundCard // サウンドカードに直接アクセスするクラス
    {
        //
        //  C#からサウンドカードを扱うためのDLLのライブラリの定義
        //
        [DllImport("SoundDll.dll", EntryPoint = "WaveFormatSetup")]
        public static extern void WaveFormatSetup(int speed);
        [DllImport("SoundDll.dll", EntryPoint = "SetupInBuffer")]
        public static extern int SetupInBuffer();
        [DllImport("SoundDll.dll", EntryPoint = "SetupOutBuffer")]
        public static extern int SetupOutBuffer();
        [DllImport("SoundDll.dll", EntryPoint = "StartCapture")]
        public static extern void StartCapture();
        [DllImport("SoundDll.dll", EntryPoint = "CheckQueue")]
        public static extern int CheckQueue();
        [DllImport("SoundDll.dll", EntryPoint = "GetRecData")]
        public static extern void GetRecData(Int16[] a);
        [DllImport("SoundDll.dll", EntryPoint = "PutPlayData")]
        public static extern void PutPlayData(Int16[] a);
        [DllImport("SoundDll.dll", EntryPoint = "HeapCleanUp")]
        public static extern void HeapCleanUp();
        //
        //  サウンドデータ(16ビット整数)から浮動小数点に変換する
        //
        public static void SoundToFloat(double[] real, double[] imag, Int16[] sound, double level)
        {
            for (int i = 0; i < 1024; i++)
            {
                real[i] = (double)sound[i * 2] / 32767.0 * level;   // +-32767を浮動小数点に
                imag[i] = (double)sound[i * 2 + 1] / 32767.0 * level;// +-32767を浮動小数点に
            }
        }
        //
        //  浮動小数点からサウンドデータ(16ビット整数)に変換する
        //
        public static void FloatToSound(Int16[] sound, double[] real, double[] imag)
        {
            for (int i = 0; i < 1024; i++)
            {
                if (real[i] >= 1.0)  // 1より大きければ
                    real[i] = 1.0;  // 上限の1にする
                else if (real[i] <= -1.0)    // 1より小さければ
                    real[i] = -1.0;  // 下限の-1にする
                if (imag[i] >= 1.0)  // 1より大きければ
                    imag[i] = 1.0;  // 上限の1にする
                else if (imag[i] <= -1.0)    // 1より小さければ
                    imag[i] = -1.0;  // 下限の-1にする
                sound[i * 2] = (Int16)(real[i] * 32767.0);  // +-1の浮動小数点を+-32767の整数にする
                sound[i * 2 + 1] = (Int16)(imag[i] * 32767.0);// 同上(虚部)
            }
        }
    }
}

